<?php
/**
 * Register a book post type.
 *
 */

class GD_Custom_Post_Type
{
    public $cplural, $splural, $csingular, $ssingular, $icon, $cb;

    public function __construct()
    {
        add_action('init', array($this, 'ganesh_custom_post'));
    }

    public function ganesh_custom_post_type($cplural, $splural, $csingular, $ssingular, $icon, $cb = "")
    {
        $labels = array(
            'name' => _x($cplural, 'post type general name', 'gd'),
            'singular_name' => _x($csingular, 'post type singular name', 'gd'),
            'menu_name' => _x($cplural, 'admin menu', 'gd'),
            'name_admin_bar' => _x($csingular, 'add new on admin bar', 'gd'),
            'add_new' => _x('Add New', $csingular, 'gd'),
            'add_new_item' => __('Add New ' . $csingular, 'gd'),
            'new_item' => __('New ' . $csingular, 'gd'),
            'edit_item' => __('Edit ' . $csingular, 'gd'),
            'view_item' => __('View ' . $csingular, 'gd'),
            'all_items' => __('All ' . $cplural, 'gd'),
            'search_items' => __('Search ' . $cplural, 'gd'),
            'parent_item_colon' => __('Parent ' . $cplural, 'gd'),
            'not_found' => __('No ' . $splural . ' found.', 'gd'),
            'not_found_in_trash' => __('No ' . $splural . ' found in Trash.', 'gd'),
        );

        $args = array(
            'labels' => $labels,
            'description' => __('Description.', 'gd'),
            'public' => true,
            'publicly_queryable' => true,
            'show_ui' => true,
            'show_in_menu' => true,
            'public' => true,
            'menu_icon' => $icon,
            'register_meta_box_cb' => $cb,
            'query_var' => true,
            'rewrite' => array('slug' => $ssingular),
            'capability_type' => 'post',
            'has_archive' => true,
            'hierarchical' => false,
            'menu_position' => null,
            'supports' => array('title', 'editor', 'thumbnail'),
        );

        register_post_type($ssingular, $args);
        flush_rewrite_rules();
    }

    public function ganesh_custom_post()
    {

        //angel_us_custom_post_type("Capitalize Plural","small plural","Capitalize Singular","small singular");

//    $this->ganesh_custom_post_type("Packages","packages","Package","package","dashicons-location");

        //$this->ganesh_custom_post_type("Sliders", "sliders", "Slider", "slider", "dashicons-desktop");

        //$this->ganesh_custom_post_type("Albums", "albums", "Album", "album", "dashicons-format-gallery");
        $this->ganesh_custom_post_type("Services", "services", "Service", "service", "dashicons-welcome-learn-more");

        //$this->ganesh_custom_post_type("Bookings","bookings","Booking","booking","dashicons-calendar");
        $this->ganesh_custom_post_type("Clients", "clients", "Client", "client", "dashicons-groups");
        $this->ganesh_custom_post_type("Teams", "teams", "Team", "team", "dashicons-groups");
        $this->ganesh_custom_post_type("Testimonials", "testimonials", "Testimonial", "testimonial", "dashicons-download");

    }

}

$gd_post_type = new GD_Custom_Post_Type();

/*

Custom Taxonomy for Posts

 */

// hook into the init action and call create_book_taxonomies when it fires

add_action('init', 'ganesh_taxonomies', 0);

// create two taxonomies, genres and writers for the post type "book"

function ganesh_taxonomies()
{

    //Africa

    all_taxonomies('Partner Categories', 'Partner Category', 'partner', 'partner_cat');

    //all_taxonomies('Package Categories', 'Package Category','package','package_cat');

}

function all_taxonomies($menu_name_p, $menu_name_s, $post_type, $taxonomy_name)
{

    $labels = array(

        'name' => _x($menu_name_p, 'taxonomy general name', 'gd'),

        'singular_name' => _x('Genre', 'taxonomy singular name', 'gd'),

        'search_items' => __('Search ' . $menu_name_p, 'gd'),

        'all_items' => __('All ' . $menu_name_p, 'gd'),

        'parent_item' => __('Parent ' . $menu_name_s, 'gd'),

        'parent_item_colon' => __('Parent ' . $menu_name_s . ': ', 'gd'),

        'edit_item' => __('Edit ' . $menu_name_s, 'gd'),

        'update_item' => __('Update ' . $menu_name_s, 'gd'),

        'add_new_item' => __('Add New ' . $menu_name_s, 'gd'),

        'new_item_name' => __('New ' . $menu_name_s . 'Name', 'gd'),

        'menu_name' => __('' . $menu_name_s, 'gd'),

    );

    $args = array(

        'hierarchical' => true,

        'labels' => $labels,

        'show_ui' => true,

        'show_in_rest' => true,

        'show_admin_column' => true,

        'query_var' => true,

        'rewrite' => array('slug' => $taxonomy_name),

    );

    register_taxonomy($taxonomy_name, array($post_type), $args);

}
